From 44ad4df19420822ca27ed94ffcfbc72ddc8a37f0 Mon Sep 17 00:00:00 2001
From: Niklas Haas <git@haasn.dev>
Date: Wed, 23 Jul 2025 13:10:57 +0200
Subject: [PATCH 14/37] avcodec/jpegxl: parse and signal correct alpha mode

This header bit ("alpha_associated") was incorrectly ignored.
---
 libavcodec/jpegxl_parse.c  | 7 +++++--
 libavcodec/jpegxl_parse.h  | 1 +
 libavcodec/jpegxl_parser.c | 5 +++++
 3 files changed, 11 insertions(+), 2 deletions(-)

diff --git a/libavcodec/jpegxl_parse.c b/libavcodec/jpegxl_parse.c
index 022eed322d..47b831e2b4 100644
--- a/libavcodec/jpegxl_parse.c
+++ b/libavcodec/jpegxl_parse.c
@@ -190,6 +190,7 @@ static void jpegxl_get_bit_depth(GetBitContext *gb, FFJXLMetadata *meta)
 static int jpegxl_read_extra_channel_info(GetBitContext *gb, FFJXLMetadata *meta, int validate)
 {
     int default_alpha = get_bits1(gb);
+    int alpha_associated = 0;
     uint32_t type, name_len = 0;
 
     if (!default_alpha) {
@@ -213,7 +214,7 @@ static int jpegxl_read_extra_channel_info(GetBitContext *gb, FFJXLMetadata *meta
     skip_bits_long(gb, name_len);
 
     if (!default_alpha && type == JPEGXL_CT_ALPHA)
-        skip_bits1(gb);
+        alpha_associated = get_bits1(gb);
 
     if (type == JPEGXL_CT_SPOT_COLOR)
         skip_bits_long(gb, 16 * 4);
@@ -221,8 +222,10 @@ static int jpegxl_read_extra_channel_info(GetBitContext *gb, FFJXLMetadata *meta
     if (type == JPEGXL_CT_CFA)
         jxl_u32(gb, 1, 0, 3, 19, 0, 2, 4, 8);
 
-    if (meta && type == JPEGXL_CT_ALPHA)
+    if (meta && type == JPEGXL_CT_ALPHA) {
         meta->have_alpha = 1;
+        meta->alpha_associated = alpha_associated;
+    }
 
     return 0;
 }
diff --git a/libavcodec/jpegxl_parse.h b/libavcodec/jpegxl_parse.h
index 0602f4d409..bb929ccee1 100644
--- a/libavcodec/jpegxl_parse.h
+++ b/libavcodec/jpegxl_parse.h
@@ -35,6 +35,7 @@ typedef struct FFJXLMetadata {
     uint32_t coded_height;
     int bit_depth;
     int have_alpha;
+    int alpha_associated;
     /*
      * offset, in bits, of the animation header
      * zero if not animated
diff --git a/libavcodec/jpegxl_parser.c b/libavcodec/jpegxl_parser.c
index 75acc53708..3981b0cec0 100644
--- a/libavcodec/jpegxl_parser.c
+++ b/libavcodec/jpegxl_parser.c
@@ -1074,6 +1074,11 @@ static void populate_fields(AVCodecParserContext *s, AVCodecContext *avctx, cons
         else
             s->format = meta->have_alpha ? AV_PIX_FMT_RGBAF32 : AV_PIX_FMT_RGBF32;
     }
+
+    if (meta->have_alpha) {
+        avctx->alpha_mode = meta->alpha_associated ? AVALPHA_MODE_PREMULTIPLIED
+                                                   : AVALPHA_MODE_STRAIGHT;
+    }
 }
 
 static int skip_icc_profile(void *avctx, JXLParseContext *ctx, GetBitContext *gb)
-- 
2.49.1


